#ifndef _MERSENNE_H_
#define _MERSENNE_H_

#include <stdio.h>

/* Period parameters */
#define N 624
#define M 397
#define MATRIX_A 0x9908b0dfUL   /* constant vector a */
#define UPPER_MASK 0x80000000UL /* most significant w-r bits */
#define LOWER_MASK 0x7fffffffUL /* least significant r bits */

extern void init_genrand(unsigned s);
extern void init_by_array(unsigned init_key[], int key_length);

extern unsigned genrand_int32(void);	/* unsigned 32-bit integers */
extern int      genrand_int31(void);		/* unsigned 31-bit integers */
extern double   genrand_real1(void);		/* uniform real in [0,1] (32-bit resolution) */
extern double   genrand_real2(void);		/* uniform real in [0,1) (32-bit resolution) */
extern double   genrand_real3(void);		/* uniform real in (0,1) (32-bit resolution) */
extern double   genrand_res53(void);		/* uniform real in [0,1) with 53-bit resolution */

#endif /* _MERSENNE_H_ */
